/*  gportal	A parallel port pin controller for Linux
 *  Copyright (C) 2002, 2003, 2004, 2005 Ben Teschendorff	
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   Contact the author:
 *	email -		stnic@users.sourceforge.net
 *
 *	snail mail - 	Ben Teschendorff
 *			692 Front Rd.
 *			Pickering, ON
 *			L1W 1N8
 *			Canada
 *
 *	gportal.c - main source file for gportal-0.4
*/

#include <gtk/gtk.h>
#include <sys/io.h>
#include <stdlib.h>
#include "misc.h"

/* declare the variables here					*/
gint s1=0;
gint s2=0;
gint s3=0;
gint s4=0;
gint s5=0;
gint s6=0;
gint s7=0;
gint s8=0;
gint total=0;
gint x;
/* gint incr; */	/* declare up here makes larger program	*/		


/* addition & pin state switching function			*/
static void big_total()
{
	total = s1+s2+s3+s4+s5+s6+s7+s8;
/* the pin switching function                                   */
	outb(total, theport);
}

/* callback function for button1				*/
static void switch_1(GtkWidget *widget, gpointer data)
{
	if(GTK_TOGGLE_BUTTON (widget)->active)
	{ s1 = 1; big_total(); }
	else
	{ s1 = 0; big_total(); }
}

/* callback function for button2                                */
static void switch_2(GtkWidget *widget, gpointer data)
{
        if(GTK_TOGGLE_BUTTON (widget)->active)
        { s2 = 2; big_total(); }
        else    
        { s2 = 0; big_total(); }
}

/* callback function for button3                                */
static void switch_3(GtkWidget *widget, gpointer data)
{
        if(GTK_TOGGLE_BUTTON (widget)->active)
        { s3 = 4; big_total(); }
        else
        { s3 = 0; big_total(); }
}

/* callback function for button4                                */
static void switch_4(GtkWidget *widget, gpointer data)
{
        if(GTK_TOGGLE_BUTTON (widget)->active)
        { s4 = 8; big_total(); }
        else
        { s4 = 0; big_total(); }
}

/* callback function for button5                                */
static void switch_5(GtkWidget *widget, gpointer data)
{
        if(GTK_TOGGLE_BUTTON (widget)->active)
        { s5 = 16; big_total(); }
        else
        { s5 = 0; big_total(); }
}

/* callback function for button6                                */
static void switch_6(GtkWidget *widget, gpointer data)
{
        if(GTK_TOGGLE_BUTTON (widget)->active)
        { s6 = 32; big_total(); }
        else
        { s6 = 0; big_total(); }
}

/* callback function for button7                                */
static void switch_7(GtkWidget *widget, gpointer data)
{
        if(GTK_TOGGLE_BUTTON (widget)->active)
        { s7 = 64; big_total(); }
        else
        { s7 = 0; big_total(); }
}

/* callback function for button8                                */
static void switch_8(GtkWidget *widget, gpointer data)
{
        if(GTK_TOGGLE_BUTTON (widget)->active)
        { s8 = 128; big_total(); }
        else
        { s8 = 0; big_total(); }
}

/* kill the app							*/
static void destroy(GtkWidget *widget, gpointer data)
{
	gtk_main_quit();
}


/* program starts here						*/

int main(int argc, char *argv[])
{

gint incr;		/* declare here makes smaller program	*/ 
GtkWidget *window;
GtkWidget *mb;
GtkWidget *frame;
GtkWidget *label;
GtkWidget *vbox1;
GtkWidget *hbox;	/* box for info, switches, exit		*/
GtkWidget *button;
const gchar *prg = "gportal-0.5";

perm();                 /* First thing - check for permission   */
outb(0, theport);


/* initialize gtk						*/
gtk_init(&argc, &argv);

/* get the styles from the gportalrc file			*/
gtk_rc_parse( "/usr/local/share/gportal/gportalrc" );


/* create the main window					*/
window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
/* gtk_window_set_title (GTK_WINDOW (window), "gportal 0.4"); */

g_signal_connect (G_OBJECT (window), "destroy",	G_CALLBACK (destroy), NULL);

/* set the border width of window				*/
gtk_container_set_border_width (GTK_CONTAINER (window), 5);

/* set the window title */
gtk_window_set_title (GTK_WINDOW (window), prg);

/* load the icon for the window */
gtk_window_set_default_icon_from_file ("/usr/local/share/gportal/gportal-icon.xpm", NULL);


/* the main box							*/
mb = gtk_hbox_new(FALSE, 10);
gtk_container_add (GTK_CONTAINER (window), mb);


/* the main vertical box					*/
vbox1 = gtk_vbox_new(FALSE, 10);
gtk_box_pack_start (GTK_BOX (mb), vbox1, FALSE, FALSE, 0);


/* the box for our labels and text 	                        */
hbox = gtk_hbox_new(FALSE, 0);
/* add hbox to window                                           */
gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 0);


/* the labels and text						*/
frame = gtk_frame_new (NULL);
label = gtk_label_new ("  gportal-0.5   Parallel Port Control");
gtk_container_add (GTK_CONTAINER (frame), label);
gtk_box_pack_start (GTK_BOX (hbox), frame, TRUE, TRUE, 0);

gtk_widget_show (frame);
gtk_widget_show (label);
gtk_widget_show (hbox);


/* the box to put the switches in				*/
hbox = gtk_hbox_new(FALSE, 5);
/* add hbox to window                                           */
gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 0);


/* make the buttons/switches					*/
for (incr = 1 ; incr < 10 ; incr++)
{
			switch (incr) {
					case 1: {
 button = gtk_toggle_button_new_with_label ("  1  ");
 g_signal_connect (G_OBJECT (button), "clicked",
                     G_CALLBACK (switch_1), NULL);
				                break;
						}
				       case 2: {
 button = gtk_toggle_button_new_with_label ("  2  ");
 g_signal_connect (G_OBJECT (button), "clicked",
                     G_CALLBACK (switch_2), NULL);
				                break;
				                }
				        case 3: {
 button = gtk_toggle_button_new_with_label ("  3  ");
 g_signal_connect (G_OBJECT (button), "clicked",
                     G_CALLBACK (switch_3), NULL);
				                break;
				                }
                                        case 4: {
 button = gtk_toggle_button_new_with_label ("  4  ");
 g_signal_connect (G_OBJECT (button), "clicked",
                     G_CALLBACK (switch_4), NULL);
                                                break;
                                                }
                                        case 5: {
 button = gtk_toggle_button_new_with_label ("  5  ");
 g_signal_connect (G_OBJECT (button), "clicked",
                     G_CALLBACK (switch_5), NULL);
                                                break;
                                                }
                                        case 6: {
 button = gtk_toggle_button_new_with_label ("  6  ");
 g_signal_connect (G_OBJECT (button), "clicked",
                     G_CALLBACK (switch_6), NULL);
                                                break;
                                                }
                                        case 7: {
 button = gtk_toggle_button_new_with_label ("  7  ");
 g_signal_connect (G_OBJECT (button), "clicked",
                     G_CALLBACK (switch_7), NULL);
                                                break;
                                                }
                                        case 8: {
 button = gtk_toggle_button_new_with_label ("  8  ");
 g_signal_connect (G_OBJECT (button), "clicked",
                     G_CALLBACK (switch_8), NULL);
                                                break;
                                                }
/* The quit button 						*/
                                        case 9: {
 button = gtk_toggle_button_new_with_label (" Exit ");
 g_signal_connect (G_OBJECT (button), "clicked",
                     G_CALLBACK (destroy),  G_OBJECT (window));
                                                break;
                                                }
				        default: {
 button = gtk_toggle_button_new_with_label (" Extra ");
				                break;
				                }
	}		/* end of switch statement		*/

gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, BUTWIDE, 0);
gtk_widget_show (button);
}

gtk_widget_show (hbox);


/* show everything						*/
gtk_widget_show (vbox1);
gtk_widget_show (mb);
gtk_widget_show (window);

gtk_main();

outb(0, theport);

return(0);
}
